package cn.com.infosec.asn1.x509;

import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.DERTaggedObject;
import cn.com.infosec.asn1.DERUTCTime;

public class V3TBSCertificateGenerator {
   DERTaggedObject version;
   DERInteger serialNumber;
   AlgorithmIdentifier signature;
   X509Name issuer;
   Time startDate;
   Time endDate;
   X509Name subject;
   SubjectPublicKeyInfo subjectPublicKeyInfo;
   X509Extensions extensions;
   private boolean altNamePresentAndCritical;

   public V3TBSCertificateGenerator() {
      V3TBSCertificateGenerator var10000 = this;
      super();
      DERTaggedObject var2;
      DERTaggedObject var10001 = var2 = new DERTaggedObject;
      DERInteger var1;
      var1 = new DERInteger.<init>(2);
      var10001.<init>(0, var1);
      var10000.version = var2;
   }

   public void setSerialNumber(DERInteger serialNumber) {
      this.serialNumber = serialNumber;
   }

   public void setSignature(AlgorithmIdentifier signature) {
      this.signature = signature;
   }

   public void setIssuer(X509Name issuer) {
      this.issuer = issuer;
   }

   public void setStartDate(DERUTCTime startDate) {
      V3TBSCertificateGenerator var10000 = this;
      Time var2;
      var2 = new Time.<init>((DERObject)startDate);
      var10000.startDate = var2;
   }

   public void setStartDate(Time startDate) {
      this.startDate = startDate;
   }

   public void setEndDate(DERUTCTime endDate) {
      V3TBSCertificateGenerator var10000 = this;
      Time var2;
      var2 = new Time.<init>((DERObject)endDate);
      var10000.endDate = var2;
   }

   public void setEndDate(Time endDate) {
      this.endDate = endDate;
   }

   public void setSubject(X509Name subject) {
      this.subject = subject;
   }

   public void setSubjectPublicKeyInfo(SubjectPublicKeyInfo pubKeyInfo) {
      this.subjectPublicKeyInfo = pubKeyInfo;
   }

   public void setExtensions(X509Extensions extensions) {
      this.extensions = extensions;
      X509Extension extensions1;
      if (extensions != null && (extensions1 = extensions.getExtension(X509Extensions.SubjectAlternativeName)) != null && extensions1.isCritical()) {
         this.altNamePresentAndCritical = true;
      }

   }

   public TBSCertificateStructure generateTBSCertificate() {
      if (this.serialNumber != null && this.signature != null && this.issuer != null && this.startDate != null && this.endDate != null && (this.subject != null || this.altNamePresentAndCritical) && this.subjectPublicKeyInfo != null) {
         ASN1EncodableVector var1;
         ASN1EncodableVector var10001 = var1 = new ASN1EncodableVector;
         var1.<init>();
         var1.add(this.version);
         var1.add(this.serialNumber);
         var1.add(this.signature);
         var10001.add(this.issuer);
         ASN1EncodableVector var2;
         ASN1EncodableVector var10002 = var2 = new ASN1EncodableVector;
         var2.<init>();
         var2.add(this.startDate);
         var10002.add(this.endDate);
         var10001.add(new DERSequence(var2));
         X509Name var5;
         if ((var5 = this.subject) != null) {
            var1.add(var5);
         } else {
            DERSequence var6;
            var6 = new DERSequence.<init>();
            var1.add(var6);
         }

         var1.add(this.subjectPublicKeyInfo);
         X509Extensions var3;
         if ((var3 = this.extensions) != null) {
            DERTaggedObject var7;
            var7 = new DERTaggedObject.<init>(3, var3);
            var1.add(var7);
         }

         DERSequence var4;
         var4 = new DERSequence.<init>(var1);
         return new TBSCertificateStructure(var4);
      } else {
         throw new IllegalStateException("not all mandatory fields set in V3 TBScertificate generator");
      }
   }
}
